<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Op.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">Op.java</span></div><h1>Op.java</h1><pre class="source lang-java linenums">/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the &quot;License&quot;); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

import org.apache.jute.Record;
import org.apache.zookeeper.common.PathUtils;
import org.apache.zookeeper.data.ACL;
import org.apache.zookeeper.proto.CheckVersionRequest;
import org.apache.zookeeper.proto.CreateRequest;
import org.apache.zookeeper.proto.DeleteRequest;
import org.apache.zookeeper.proto.SetDataRequest;

import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

/**
 * Represents a single operation in a multi-operation transaction.  Each operation can be a create, update
 * or delete or can just be a version check.
 *
 * Sub-classes of Op each represent each detailed type but should not normally be referenced except via
 * the provided factory methods.
 *
 * @see ZooKeeper#create(String, byte[], java.util.List, CreateMode)
 * @see ZooKeeper#create(String, byte[], java.util.List, CreateMode, org.apache.zookeeper.AsyncCallback.StringCallback, Object)
 * @see ZooKeeper#delete(String, int)
 * @see ZooKeeper#setData(String, byte[], int)
 */
public abstract class Op {
    private int type;
    private String path;

    // prevent untyped construction
<span class="fc" id="L49">    private Op(int type, String path) {</span>
<span class="fc" id="L50">        this.type = type;</span>
<span class="fc" id="L51">        this.path = path;</span>
<span class="fc" id="L52">    }</span>

    /**
     * Constructs a create operation.  Arguments are as for the ZooKeeper method of the same name.
     * @see ZooKeeper#create(String, byte[], java.util.List, CreateMode)
     * @see CreateMode#fromFlag(int)
     *
     * @param path
     *                the path for the node
     * @param data
     *                the initial data for the node
     * @param acl
     *                the acl for the node
     * @param flags
     *                specifying whether the node to be created is ephemeral
     *                and/or sequential but using the integer encoding.
     */
    public static Op create(String path, byte[] data, List&lt;ACL&gt; acl, int flags) {
<span class="fc" id="L70">        return new Create(path, data, acl, flags);</span>
    }

    /**
     * Constructs a create operation.  Arguments are as for the ZooKeeper method of the same name.
     * @see ZooKeeper#create(String, byte[], java.util.List, CreateMode)
     *
     * @param path
     *                the path for the node
     * @param data
     *                the initial data for the node
     * @param acl
     *                the acl for the node
     * @param createMode
     *                specifying whether the node to be created is ephemeral
     *                and/or sequential
     */
    public static Op create(String path, byte[] data, List&lt;ACL&gt; acl, CreateMode createMode) {
<span class="fc" id="L88">        return new Create(path, data, acl, createMode);</span>
    }

    /**
     * Constructs a delete operation.  Arguments are as for the ZooKeeper method of the same name.
     * @see ZooKeeper#delete(String, int)
     *
     * @param path
     *                the path of the node to be deleted.
     * @param version
     *                the expected node version.
     */
    public static Op delete(String path, int version) {
<span class="fc" id="L101">        return new Delete(path, version);</span>
    }

    /**
     * Constructs an update operation.  Arguments are as for the ZooKeeper method of the same name.
     * @see ZooKeeper#setData(String, byte[], int)
     *
     * @param path
     *                the path of the node
     * @param data
     *                the data to set
     * @param version
     *                the expected matching version
     */
    public static Op setData(String path, byte[] data, int version) {
<span class="fc" id="L116">        return new SetData(path, data, version);</span>
    }


    /**
     * Constructs an version check operation.  Arguments are as for the ZooKeeper.setData method except that
     * no data is provided since no update is intended.  The purpose for this is to allow read-modify-write
     * operations that apply to multiple znodes, but where some of the znodes are involved only in the read,
     * not the write.  A similar effect could be achieved by writing the same data back, but that leads to
     * way more version updates than are necessary and more writing in general.
     *
     * @param path
     *                the path of the node
     * @param version
     *                the expected matching version
     */
    public static Op check(String path, int version) {
<span class="fc" id="L133">        return new Check(path, version);</span>
    }

    /**
     * Gets the integer type code for an Op.  This code should be as from ZooDefs.OpCode
     * @see ZooDefs.OpCode
     * @return  The type code.
     */
    public int getType() {
<span class="fc" id="L142">        return type;</span>
    }

    /**
     * Gets the path for an Op.
     * @return  The path.
     */
    public String getPath() {
<span class="fc" id="L150">        return path;</span>
    }

    /**
     * Encodes an op for wire transmission.
     * @return An appropriate Record structure.
     */
    public abstract Record toRequestRecord() ;

    /**
     * Reconstructs the transaction with the chroot prefix.
     * 
     * @return transaction with chroot.
     */
    abstract Op withChroot(String addRootPrefix);

    /**
     * Performs client path validations.
     * 
     * @throws IllegalArgumentException
     *             if an invalid path is specified
     * @throws KeeperException.BadArgumentsException
     *             if an invalid create mode flag is specified
     */
    void validate() throws KeeperException {
<span class="fc" id="L175">        PathUtils.validatePath(path);</span>
<span class="fc" id="L176">    }</span>

    //////////////////
    // these internal classes are public, but should not generally be referenced.
    //
    public static class Create extends Op {
        private byte[] data;
        private List&lt;ACL&gt; acl;
        private int flags;

        private Create(String path, byte[] data, List&lt;ACL&gt; acl, int flags) {
<span class="fc" id="L187">            super(ZooDefs.OpCode.create, path);</span>
<span class="fc" id="L188">            this.data = data;</span>
<span class="fc" id="L189">            this.acl = acl;</span>
<span class="fc" id="L190">            this.flags = flags;</span>
<span class="fc" id="L191">        }</span>

        private Create(String path, byte[] data, List&lt;ACL&gt; acl, CreateMode createMode) {
<span class="fc" id="L194">            super(ZooDefs.OpCode.create, path);</span>
<span class="fc" id="L195">            this.data = data;</span>
<span class="fc" id="L196">            this.acl = acl;</span>
<span class="fc" id="L197">            this.flags = createMode.toFlag();</span>
<span class="fc" id="L198">        }</span>

        @Override
        public boolean equals(Object o) {
<span class="pc bpc" id="L202" title="1 of 2 branches missed.">            if (this == o) return true;</span>
<span class="pc bpc" id="L203" title="1 of 2 branches missed.">            if (!(o instanceof Create)) return false;</span>

<span class="fc" id="L205">            Create op = (Create) o;</span>

<span class="fc" id="L207">            boolean aclEquals = true;</span>
<span class="fc" id="L208">            Iterator&lt;ACL&gt; i = op.acl.iterator();</span>
<span class="fc bfc" id="L209" title="All 2 branches covered.">            for (ACL acl : op.acl) {</span>
<span class="fc" id="L210">                boolean hasMoreData = i.hasNext();</span>
<span class="pc bpc" id="L211" title="1 of 2 branches missed.">                if (!hasMoreData) {</span>
<span class="nc" id="L212">                    aclEquals = false;</span>
<span class="nc" id="L213">                    break;</span>
                }
<span class="fc" id="L215">                ACL otherAcl = i.next();</span>
<span class="pc bpc" id="L216" title="1 of 2 branches missed.">                if (!acl.equals(otherAcl)) {</span>
<span class="nc" id="L217">                    aclEquals = false;</span>
<span class="nc" id="L218">                    break;</span>
                }
<span class="fc" id="L220">            }</span>
<span class="pc bpc" id="L221" title="5 of 10 branches missed.">            return !i.hasNext() &amp;&amp; getType() == op.getType() &amp;&amp; Arrays.equals(data, op.data) &amp;&amp; flags == op.flags &amp;&amp; aclEquals;</span>
        }

        @Override
        public int hashCode() {
<span class="fc" id="L226">            return getType() + getPath().hashCode() + Arrays.hashCode(data);</span>
        }

        @Override
        public Record toRequestRecord() {
<span class="fc" id="L231">            return new CreateRequest(getPath(), data, acl, flags);</span>
        }

        @Override
        Op withChroot(String path) {
<span class="fc" id="L236">            return new Create(path, data, acl, flags);</span>
        }

        @Override
        void validate() throws KeeperException {
<span class="fc" id="L241">            CreateMode createMode = CreateMode.fromFlag(flags);</span>
<span class="fc" id="L242">            PathUtils.validatePath(getPath(), createMode.isSequential());</span>
<span class="fc" id="L243">        }</span>
    }

    public static class Delete extends Op {
        private int version;

        private Delete(String path, int version) {
<span class="fc" id="L250">            super(ZooDefs.OpCode.delete, path);</span>
<span class="fc" id="L251">            this.version = version;</span>
<span class="fc" id="L252">        }</span>

        @Override
        public boolean equals(Object o) {
<span class="pc bpc" id="L256" title="1 of 2 branches missed.">            if (this == o) return true;</span>
<span class="pc bpc" id="L257" title="1 of 2 branches missed.">            if (!(o instanceof Delete)) return false;</span>

<span class="fc" id="L259">            Delete op = (Delete) o;</span>

<span class="pc bpc" id="L261" title="2 of 4 branches missed.">            return getType() == op.getType() &amp;&amp; version == op.version </span>
<span class="pc bpc" id="L262" title="1 of 2 branches missed.">                   &amp;&amp; getPath().equals(op.getPath());</span>
        }

        @Override
        public int hashCode() {
<span class="fc" id="L267">            return getType() + getPath().hashCode() + version;</span>
        }

        @Override
        public Record toRequestRecord() {
<span class="fc" id="L272">            return new DeleteRequest(getPath(), version);</span>
        }

        @Override
        Op withChroot(String path) {
<span class="fc" id="L277">            return new Delete(path, version);</span>
        }
    }

    public static class SetData extends Op {
        private byte[] data;
        private int version;

        private SetData(String path, byte[] data, int version) {
<span class="fc" id="L286">            super(ZooDefs.OpCode.setData, path);</span>
<span class="fc" id="L287">            this.data = data;</span>
<span class="fc" id="L288">            this.version = version;</span>
<span class="fc" id="L289">        }</span>

        @Override
        public boolean equals(Object o) {
<span class="pc bpc" id="L293" title="1 of 2 branches missed.">            if (this == o) return true;</span>
<span class="pc bpc" id="L294" title="1 of 2 branches missed.">            if (!(o instanceof SetData)) return false;</span>

<span class="fc" id="L296">            SetData op = (SetData) o;</span>

<span class="pc bpc" id="L298" title="2 of 4 branches missed.">            return getType() == op.getType() &amp;&amp; version == op.version </span>
<span class="pc bpc" id="L299" title="2 of 4 branches missed.">                   &amp;&amp; getPath().equals(op.getPath()) &amp;&amp; Arrays.equals(data, op.data);</span>
        }

        @Override
        public int hashCode() {
<span class="fc" id="L304">            return getType() + getPath().hashCode() + Arrays.hashCode(data) + version;</span>
        }

        @Override
        public Record toRequestRecord() {
<span class="fc" id="L309">            return new SetDataRequest(getPath(), data, version);</span>
        }

        @Override
        Op withChroot(String path) {
<span class="fc" id="L314">            return new SetData(path, data, version);</span>
        }
    }

    public static class Check extends Op {
        private int version;

        private Check(String path, int version) {
<span class="fc" id="L322">            super(ZooDefs.OpCode.check, path);</span>
<span class="fc" id="L323">            this.version = version;</span>
<span class="fc" id="L324">        }</span>

        @Override
        public boolean equals(Object o) {
<span class="pc bpc" id="L328" title="1 of 2 branches missed.">            if (this == o) return true;</span>
<span class="pc bpc" id="L329" title="1 of 2 branches missed.">            if (!(o instanceof Check)) return false;</span>

<span class="fc" id="L331">            Check op = (Check) o;</span>

<span class="pc bpc" id="L333" title="3 of 6 branches missed.">            return getType() == op.getType() &amp;&amp; getPath().equals(op.getPath()) &amp;&amp; version == op.version;</span>
        }

        @Override
        public int hashCode() {
<span class="fc" id="L338">            return getType() + getPath().hashCode() + version;</span>
        }

        @Override
        public Record toRequestRecord() {
<span class="fc" id="L343">            return new CheckVersionRequest(getPath(), version);</span>
        }

        @Override
        Op withChroot(String path) {
<span class="fc" id="L348">            return new Check(path, version);</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>